# 
# ZipTbl
#

=Head1 Description

ZipTbl -- Gather Zip file information *into* HTML Table

=Head1 Synopsis

perl -S ZIPTBL.PL >Tbl_Prt.htm

=Head1 Output sample

<TR>
<TD><CENTER>
<A HREF="GrabIt.ZIP">GrabIt.zip*</A></CENTER>

<table width=100%> 
<tr>
  <td align="left">
  <B>Size:</B>
  <td align="right"> 
  52769
</tr>
<tr>
  <td align="left">
  <B>Date:</B>
  <td align="right"> 
   Jul 15,97
</tr>
</table>

<TD>Extremely SMALL &amp; USEFUL tool to grab the file name with full path
into clipboard. Works for win95/winNT. 
</TD>
</TR>

=cut

# == Constant setting

# == Script begins 

$DizDir='./Exp/';  # the diz files are in the Exp dir, which
				   # means expand directory

# get the zip file list for current dir
@zl=<"*.zip">;
@zl=sort { uc($a) cmp uc($b)} @zl;

print qq{<body>\n
<!-- automatic generation begin -->

<TABLE BORDER=1 >
<TR>
  <TD>&nbsp;</TD>
  <TD><B><FONT SIZE=+1>My Free Utilities</FONT></B></TD>
</TR>
};

foreach $zipfile (@zl){
	
	# get info for the file
	($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,
		$atime,$mtime,$ctime,$blksize,$blocks)
		= stat($zipfile);
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =
			localtime(time-$mtime);  # How old is it
	my $day_old=$mon*30+$mday;
	#warn "$zipfile $day_old\n";
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =
			localtime($mtime);	# get the modify time
	$london_month = (qw(Jan Feb Mar Apr May Jun
			Jul Aug Sep Oct Nov Dec))[$mon];
	
	#print it
	print 
		"<TR>\n  <TD><CENTER>\n" .
		"  <A HREF=\"$zipfile\">$zipfile</A></CENTER>\n\n" .

		"  <table width=100%>\n  <tr>\n" ;
	printf 
		"    <td align=left><B>Size:</B></td>\n".
		"    <td align=right><pre>$size</pre></td>\n" .
		"  </tr>\n  <tr>\n" .
		"    <td align=left><B>Date:</B></td>\n".
		"    <td align=right><pre>$london_month $mday,$year</pre></td>\n".
		"  </tr>\n  </table>\n  </TD>\n";
	
	my $FileName = $DizDir . $zipfile;
	substr($FileName,-4)="";
	$FileName .= '.diz';
	#warn "$FileName\n";
	
	print "\n<TD>";
	
	# -- diz Field
	if ($day_old<=30){
		print "\n <FONT COLOR=#FF0000>New!";
		if ($day_old<=20){
			print "!";}
		if ($day_old<=10){
			print "!";}
		print "</FONT>&nbsp;\n";
		}
	
	# -- Output diz info
	if( -e $FileName ){
		open(INPUT,"<$FileName") ||
			die "Can't input $FileName $!";
		@FileC=<INPUT>;
		close INPUT;
		# "ZDNet filekey: "
		print "@FileC";
		}
	else {
		print '&nbsp;';
		}
	
	# -- Link to .htm page
	$FileName = $zipfile;
	substr($FileName,-4)="";
	$FileName .= '.htm';
	$FileName = lc($FileName);	# to lower!!!
	#warn "$FileName\n";
	if( -e $FileName ){
		print " \n<A HREF=\"$FileName\">". 
		"See somewhat detail infomation for $zipfile</A>\n";
		}
	#else {print "No exist!"}
	
	print "</TD>\n</TR>\n";
	}

print "\n</TABLE>\n";

print qq{\n<!-- notice: Time stamp & author -->
<table width=100%>
 <tr>  
  <td align=left><I><B>Table last updated: </B>}
 . localtime(). "</I>". qq{
  <td align=right>Copyright &copy; 1997-98 
   <A HREF="Myself.htm">SUN Tong</A> 
   <A HREF="mailto: suntong\@geocities.com"><ADDRESS>suntong\@geocities.com</ADDRESS></A>
 </tr>
</table>} ;

print "\n
<!-- automatic generation end -->
</body>";
